## Install and Running:
1. Copy ```.env.example``` to ```.env```
2. Replace ```.env``` values according to your environment 
3. Run
```
npm install
```
4. To start backend server, run
```
npm start
```
5. Do work. Any changes in the backend will be automatically updated. No more turning the server on and off again! :)
6. Good luck have fun!

## File Structure
```
backend
+-- src
|   +-- config
|   |   +-- config.js     (Secret key & expiration JWT. Add Role string here when adding new role.)
|   |   +-- db.config.js  (Database and Sequelize config)
|   |   +-- env.js        (Wrapper for env variables)
|   |
|   +-- controller
|   |   +-- *Controller.js (Add your controllers here)
|   |
|   +-- model
|   |   +-- *.model.js (Add models here and follow the name convention)
|   |
|   +-- router
|   |   +-- router.js         (Routing goes here)
|   |   +-- verifyJwtToken.js (Middleware functions involving JWT token should go here)
|   |   +-- verifySignUp.js   (Middleware functions involving Sign Up)
|   +-- app.js
+-- .env.example (Example of .env file. Please copy this to .env and set it to your env)
```