const db = require('../config/db.config.js');
const config = require('../config/config.js');
var jwt = require('jsonwebtoken');
var bcrypt = require('bcryptjs');
const User = db.user;
const Role = db.role;

exports.signup = (req, res) => {
    console.log("Processing func -> signup");
    User.create({
        name: req.body.name, 
        email: req.body.email,
        username: req.body.username,
        password: bcrypt.hashSync(req.body.password)
    }).then(user => {
        Role.findOne({
            where: {
                name: req.body.role
            }
        }).then(role => {
            user.setRole(role).then(() => {
                res.send("User registered successfully!");
            })
        }).catch(err => {
            res.status(500).send('Error -> ' + err);
        });
    }).catch(err => {
        res.status(500).send('Fail! Error -> ' + err);
    });
}

exports.signin = (req, res) => {
    console.log('Sign in');

    User.findOne({
        where: {
            username: req.body.username
        }
    }).then(user => {
        if(!user) {
            return res.status(404).send('User not found!');
        }

        var isPasswordValid = bcrypt.compareSync(req.body.password, user.password);
        if(!isPasswordValid) {
            return res.status(401).send({
                auth: false,
                accessToken: null,
                reason: "Invalid password!"
            });
        }

        var token = jwt.sign({id: user.id}, config.secret, {
            expiresIn: config.jwtExpireTime
        });

        res.status(200).send({
            auth: true,
            accessToken: token
        });
    }).catch(err => {
        res.status(500).send('Error -> ' + err);
    });
}
