const verifySignUp = require('./verifySignUp');
const authJwt = require('./verifyJwtToken');

module.exports = function(app) {
    const authController = require('../controller/authController.js');
    const testController = require('../controller/testController.js');
    app.post('/api/auth/signup', [verifySignUp.checkDuplicateUserNameOrEmail, verifySignUp.checkRolesExisted], authController.signup);
    app.post('/api/auth/login', authController.signin);

    app.get('/api/test/admin', [authJwt.verifyToken, authJwt.isAdmin], testController.adminContent);
    app.get('/api/test/member', [authJwt.verifyToken], testController.memberContent);
    // Sample Hello
    var hello = require('../controller/hello')
    app.route('/hello').get(hello.index)
}