const jwt = require('jsonwebtoken');
const config = require('../config/config.js');
const db = require('../config/db.config.js');
const User = db.user;
const Role = db.role;

verifyToken = (req, res, next) => {
    let token = req.headers['x-access-token'];

    if (!token) {
        res.status(403).send({
            message: 'No token provided!',
            auth: false
        });
        return;
    }

    jwt.verify(token, config.secret, (err, decoded) => {
        if (err) {
            return res.status(500).send({
                message: 'Fail to auth. Error -> ' + err,
                auth: false
            });
        }
        req.userId = decoded.id;
        next();
    });
}

isAdmin = (req, res, next) => {
    User.findByPk(req.userId)
        .then(user => {
            user.getRole().then(role => {
                if (role === 'Master Admin Diskominfo' || role === 'Admin Diskominfo' || role === 'Admin Dinas') {
                    next();
                    return;
                }
                res.status(403).send('Require Admin Role!');
                return;
            })
        })
}

const verifyJwtToken = {};
verifyJwtToken.verifyToken = verifyToken;
verifyJwtToken.isAdmin = isAdmin;

module.exports = verifyJwtToken;